﻿using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TextEditorInGridCaptureTextONntering
{
    internal class MyControlContainerEditor : ControlContainerEditor
    {        
        public void RaiseValueChangeEventInternal()
        {
            // This is an internal protected method, so we can only call it from a derived class. 
            this.RaiseValueChangedEvent();
        }

        protected override void ApplyOwnerAppearance(ControlType controlType, ref AppearanceData appearance)
        {            
            base.ApplyOwnerAppearance(controlType, ref appearance);

            var control = this.GetControl(controlType);
            if (appearance.HasPropertyBeenSet(AppearancePropFlags.ForeColor))
                control.ultraTextEditor1.Appearance.ForeColor = appearance.ForeColor;
            else
                control.ultraTextEditor1.Appearance.ResetForeColor();

            if (appearance.HasPropertyBeenSet(AppearancePropFlags.BackColor))
                control.ultraTextEditor1.Appearance.BackColor = appearance.BackColor;
            else
                control.ultraTextEditor1.Appearance.ResetBackColor();
        }

        private ucTextCol GetControl(ControlType controlType)
        {
            switch (controlType)
            {
                case ControlType.Editing:
                    return (ucTextCol)this.EditingControl;
                case ControlType.Rendering:
                    return (ucTextCol)this.RenderingControl;
                default:
                    Debug.Fail("Unknown ControlType");
                    return null;
            }            
        }

    }
}
